# rotten.tcl v1.0 by domsen <domsen@domsen.org> (c)2oo3
#
# comments? bugs? ideas? requests? money? beer? 
# plz mail me or visit my homepage @ www.domsen.org
#
# rotten.tcl searches for new headlines on rotten.com and posts them to your channels
# whenever there is a new one. the script can also be a newshub for other leafbots and
# will tell you the latest headlines by command. 
#
# v1.0 - first public version
#
# rottentrigger - the trigger the bot respons to (public and message)
# rottenimit -the maximum number of news the bot posts (on cmd)
# rottennewspost  - 1 for newsposting, 0 for none
# rottenchans  - the chans the script is active in, "" for all
# rottennewspostlimit - the maximum  news the bot posts (newsposting)
# rottendehub  - 1 enables the hub function, 0 disables it
# rottenleafs  - the bots the leaf tcl is running on
#
####### config ######################

set rottentrigger ".rotten"
set rottenchans ""
set rottenlimit "5"
set rottennewspostlimit "3"
set rottennewspost "1"
set isrottenhub "0"
set rottenleafs ""

####### end of config ###############

bind msg - $rottentrigger msg_rotten
bind pub - $rottentrigger pub_rotten
bind time - "?0 * * * *" rottencheck

proc sendrottennews { arg } {
global rottenleafs
foreach bot [bots] {
if {([lsearch -exact [string tolower $rottenleafs] [string tolower $bot]] != -1)} {
putbot $bot "rotten: $arg"
}}}

proc shrink { calc number string start bl} { return [expr [string first "$string" $bl $start] $calc $number] }

proc rottennews { target limit } {
if {[catch {set sock [socket www.dailyrotten.com 80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET / HTTP/1.1"
puts $sock "User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)"
puts $sock "Host: www.dailyrotten.com"
puts $sock "Connection: close"
puts $sock ""
flush $sock
set counter 0
while {[eof $sock] != 1} {
set bl [gets $sock]
if {[string first "class=\"newslink\">" $bl] != -1} {
set link "[string range $bl [shrink + 7 " href=\"" 0 $bl] [shrink - 1 "\" target=" 0 $bl]]"
regsub -all "&amp" $link "&" link
set newsline [string range $bl [shrink + 5 "ink\">" 0 $bl] [shrink - 1 "</a>" 0 $bl]]
putserv "privmsg $target :[incr counter] $newsline <$link>"
}
if {$counter == $limit} {close $sock; return 0}
}}}


proc rottencheck {nick uhost hand chan arg} {
global rottenchans rottennewspost isrottenhub rottennewspostlimit
set counter 0
if {$rottennewspost == 1 } {
putlog "rotten: searching for new headline"
set rottenlastnews "none"
if {[file exists rotten.hdl]} {
set temp [open "rotten.hdl" r]
set rottenlastnews "[gets $temp]"
if {$rottenlastnews == ""} { set rottenlastnews "none" }
close $temp
}
set temp [open "rotten.hdl" w+]
if {[catch {set sock [socket www.dailyrotten.com 80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET / HTTP/1.1"
puts $sock "User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)"
puts $sock "Host: www.dailyrotten.com"
puts $sock "Connection: close"
puts $sock ""
flush $sock
while {[eof $sock] != 1} {
set bl [gets $sock]
if {[string first "class=\"newslink\">" $bl] != -1} {
set link "[string range $bl [shrink + 7 " href=\"" 0 $bl] [shrink - 1 "\" target=" 0 $bl]]"
regsub -all "&amp" $link "&" link
set newsline [string range $bl [shrink + 5 "ink\">" 0 $bl] [shrink - 1 "</a>" 0 $bl]]
puts $temp "$newsline <$link>"
}}}
close $sock ; close $temp
if {$rottenlastnews == "none" } { putlog "rotten: headlinefile created" ; return 0 }
set temp [open "rotten.hdl" r]
while { [eof $temp] != 1 } {
set rottenneunews [gets $temp]
if {($rottenlastnews == $rottenneunews) || ($counter == $rottennewspostlimit)} { close $temp;return 0 }
if { $isrottenhub == "1" } { sendrottennews $rottenneunews }
incr counter
foreach chan [channels] {
if {$rottenchans == "" } { putserv "privmsg $chan :(new rotten headline) $rottenneunews" }
if {$rottenchans != "" } {
if {([lsearch -exact [string tolower $rottenchans] [string tolower $chan]] != -1) || ($rottenchans == "")} {putserv "privmsg $chan :(new rotten headline) $rottenneunews"}
}
}}}}


proc msg_rotten { nick uhost hand arg } { global rottenlimit ; rottennews $nick $rottenlimit }
proc pub_rotten { nick uhost hand chan arg } { global rottenchans rottenlimit ; if {([lsearch -exact [string tolower $rottenchans] [string tolower $chan]] != -1) || ($rottenchans == "")} { rottennews $nick $rottenlimit }}


putlog "*** rotten.tcl v1.0 by domsen <domsen@domsen.org> succesfully loaded"

#[EOF]
